version: "3"
services:
  app:
    build:
      context: ./app
      dockerfile: Dockerfile
    container_name: "cookie-maker"
    ports:
      - "8080:8080"

    environment:
      - NODE_ENV=development
      # - CHOKIDAR_USEPOLLING=true
    volumes:
      - ./app:/app
      # - ./ssl:/ssl
    networks:
      - cookie-maker
  api:
    build:
      context: ./api
      dockerfile: Dockerfile
    depends_on:
      - db
    container_name: "cookie-api"
    ports:
      - "5000:5000"
      - "4999:4999"
    environment:
      - NODE_ENV=development
    volumes:
      - ./api:/api
      - ./ssl:/ssl
    networks:
      - cookie-maker

  db:
    # restart: always
    build:
      context: ./db
      dockerfile: Dockerfile
    container_name: "mongodb"
    ports:
      - "27017:27017"
    environment:
      - MONGO_INITDB_ROOT_USERNAME=user
      - MONGO_INITDB_ROOT_PASSWORD=user123
      - MONGO_INITDB_DATABASE=cookie-shop
    volumes:
      - big-app-mongodb:/data/db
    networks:
      - cookie-maker

  postgres:  
    image: postgres:14
    container_name: 'cookie-keycloak-postgers'
    volumes:
      - postgres-keycloack-data:/var/lib/postgresql/data
    environment:
      POSTGRES_DB: keycloak
      POSTGRES_USER: keycloak
      POSTGRES_PASSWORD: password
    networks:
      - cookie-keycloack
  keycloak:
    # restart: always
    image: jboss/keycloak:11.0.1
    container_name: 'cookie-keycloak'
    hostname: 'cookie-keycloak'
    environment:
      DB_VENDOR: POSTGRES
      DB_ADDR: postgres
      DB_DATABASE: keycloak
      DB_USER: keycloak
      DB_SCHEMA: public
      DB_PASSWORD: password
      KEYCLOAK_USER: admin
      KEYCLOAK_PASSWORD: admin
      # Uncomment the line below if you want to specify JDBC parameters. The parameter below is just an example, and it shouldn't be used in production without knowledge. It is highly recommended that you read the PostgreSQL JDBC driver documentation in order to use it.
      # JDBC_PARAMS: "ssl=true"
    ports:
      - 8082:8443
      - 466:465
    volumes:
      - ./ssl:/etc/x509/https
      # - ./app/ssl/tsl.crt:/etc/x509/https/tsl.crt
      # - ./app/ssl/tsl.key:/etc/x509/https/tsl.key
    depends_on:
      - postgres
    networks:
      - cookie-keycloack
volumes:
  big-app-mongodb:
    driver: local
  postgres-keycloack-data:
    driver: local
networks:
  cookie-maker:
  cookie-keycloack:
